#!/usr/bin/python3.7
# dac8532.py
#
# Copyright (c) 2020 Spring City Solutions LLC and other contributors
# Licensed under the Apache License, Version 2.0
#
# Need to have the rpi.gpio and spidev python libraries installed
#
# https://www.waveshare.com/High-Precision-AD-DA-Board.htm
# https://www.waveshare.com/wiki/High-Precision_AD/DA_Board
# https://github.com/waveshare/High-Precision-AD-DA-Board
# https://gitlab.com/SpringCitySolutionsLLC/waveshare-shield-adda-11010
# https://npmjs.org/package/node-red-contrib-waveshare-shield-adda-11010
# https://flows.nodered.org/node/node-red-contrib-waveshare-shield-adda-11010
# https://nodered.org/
# Links for ADS1256 chip:
# https://www.ti.com/product/ADS1256
# https://www.ti.com/lit/gpn/ads1256
# Link for LM285 chip, connected to the ADS1256:
# https://www.ti.com/product/LM285-2.5-N
# https://www.ti.com/lit/gpn/lm285-2.5-n
# Link for DAC8532 chip:
# https://www.ti.com/product/DAC8532
# https://www.ti.com/lit/gpn/dac8532
#
# Usage:
#
# dac8532.py "port A or B" "integer value 0 to 65535"
#

import RPi.GPIO as GPIO
import spidev
import sys

cs = 23
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
GPIO.setup(cs, GPIO.OUT)
GPIO.output(cs, 1)

spi = spidev.SpiDev()
spi.open(0, 0)
spi.max_speed_hz = 20000
spi.mode = 0b01

firstbyte = 0x30

if sys.argv[1] == "A":
    firstbyte = 0x30
if sys.argv[1] == "B":
    firstbyte = 0x34

secondbyte = int(sys.argv[2]) >> 8
thirdbyte = int(sys.argv[2]) & 0xFF

GPIO.output(cs, 0)
spi.writebytes([firstbyte, secondbyte, thirdbyte])
GPIO.output(cs, 1)
