#!/usr/bin/python3.7
# gpio.py
#
# Copyright (c) 2020 Spring City Solutions LLC and other contributors
# Licensed under the Apache License, Version 2.0
#
# Need to have the rpi.gpio python library installed
#
# https://www.waveshare.com/High-Precision-AD-DA-Board.htm
# https://www.waveshare.com/wiki/High-Precision_AD/DA_Board
# https://github.com/waveshare/High-Precision-AD-DA-Board
# https://gitlab.com/SpringCitySolutionsLLC/waveshare-shield-adda-11010
# https://npmjs.org/package/node-red-contrib-waveshare-shield-adda-11010
# https://flows.nodered.org/node/node-red-contrib-waveshare-shield-adda-11010
# https://nodered.org/
# Links for ADS1256 chip:
# https://www.ti.com/product/ADS1256
# https://www.ti.com/lit/gpn/ads1256
# Link for LM285 chip, connected to the ADS1256:
# https://www.ti.com/product/LM285-2.5-N
# https://www.ti.com/lit/gpn/lm285-2.5-n
# Link for DAC8532 chip:
# https://www.ti.com/product/DAC8532
# https://www.ti.com/lit/gpn/dac8532
#
# Usage:
#
# gpio.py in "P22 to P25"
# returns 0 or 1 as per input to the specified pin
#
# gpio.py out "P22 to P25" "0 or 1"
#
# Some notes on wiring:
# Labeled header P22 is connected to physical pin 31 connected to BCM port 6
# Labeled header P23 is connected to physical pin 33 connected to BCM port 13
# Labeled header P24 is connected to physical pin 35 connected to BCM port 19
# Labeled header P25 is connected to physical pin 37 connected to BCM port 26
#

import RPi.GPIO as GPIO
import sys

GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

pin = 6
if (sys.argv[2] == 'P22'):
    pin = 6
if (sys.argv[2] == 'P23'):
    pin = 13
if (sys.argv[2] == 'P24'):
    pin = 19
if (sys.argv[2] == 'P25'):
    pin = 26

if (sys.argv[1] == 'in'):
    GPIO.setup(pin, GPIO.IN)
    print(GPIO.input(pin))

if (sys.argv[1] == 'out'):
    GPIO.setup(pin, GPIO.OUT)
    GPIO.output(pin, int(sys.argv[3]))
